/**************************************************************************
 *
 *  Jeu de la Vie 1.1 - 02/04/2004
 *
 *  Copyright (C) 2001-2003 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Jeu de la Vie.
 *
 *	Jeu de la Vie is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Jeu de la Vie is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


#include "vie.h"
#include "divers.h"
#include "regles.h"
#include "interruptions.h"
#include "clavier.h"
#include "var.h"
#include "texte.h"
#include "graphiques.h"
#include "menus.h"


////////////////////////////////////////////////////////////////////////////////////////////////////////

void _main(void)
{
	SCR_RECT rect ;
	WIN_RECT winrect ;
	unsigned char *var, *lettre, *lcd, *bmp, *terrain, nom[19], gen[6], *ch ;
	short x, rang, mode, decal, attend = 0 ;
	unsigned short generation ;
	long ptr ;

	Tampon = malloc(2736) ; terrain = malloc(2480) ; bmp = malloc(2480) ; lcd = malloc(3840) ;
	if (lcd == NULL) goto Fin ;
	baisse_contraste(20) ;
	randomize() ; Vieilles[_89_92(1,6)] = 0xFF ;
	#ifdef _92
		Vieilles[9] = 0xFF ;
	#endif
//	srand(27) ;
	init_int() ; init_alphabet() ; verif_motifs() ;
	LCD_save(lcd) ; restaure_contraste() ; disp_intro() ; baisse_contraste(100) ;
	set_taille_terrain() ; nouveau() ;

	while (1)
	{
		OSSetSR(0x0700) ;
		generation = 0 ;
		draw_interface() ;
		restaure_contraste() ;
		prepare_tampon(Tampon) ;
		while (ON == 0)
		{
			*(long*)0x55DA &= 0b11111111111100000000000000000000 ;	// Efface le compteur prcdent...
			*(long*)0x55F8 &= 0b11111111111100000000000000000000 ;
			*(long*)0x5616 &= 0b11111111111100000000000000000000 ;
			*(long*)0x5634 &= 0b11111111111100000000000000000000 ;
			*(long*)0x5652 &= 0b11111111111100000000000000000000 ;
			__my_sprintf__(gen, generation++) ;						// et rcris le nouveau, fonction perso par Lionel Debroux
			for (ch = gen, x = 12 ; *ch ; ch++, x += 4)
			{
				lettre = Alphabet+5**ch ;
				decal = 24-(x&15) ;
				ptr = (long)0x55DA+((x>>3)&0xFFFE) ;

				*(long*)ptr |= (long)(*lettre++)<<decal ;
				*(long*)(ptr+30) |= (long)(*lettre++)<<decal ;
				*(long*)(ptr+60) |= (long)(*lettre++)<<decal ;
				*(long*)(ptr+90) |= (long)(*lettre++)<<decal ;
				*(long*)(ptr+120) |= (long)(*lettre)<<decal ;
			}
			Moteur() ;
			if (attend != 0)
				asm("
				boucle01:
					move.w	#1020,%%d0
				boucle03:
					dbra	%%d0,boucle03
					dbra	%0,boucle01
				" :: "d" (attend) : "d0") ;
		}
		baisse_contraste(100) ;
		x1 = MilieuTerrainX ; y1 = MilieuTerrainY ;
		draw_menu() ;
		rang = 0 ; SavTerrain(terrain) ;
		restaure_contraste() ;
		while (1)
		{
			DrawChar(1, 6+8*rang, 18, 4) ;
			attend_touche(ANIMER_CELLULE) ;
			DrawStr(1, 6+8*rang, "  ", 4) ;
			rang = (7+rang+(BAS != 0)-(HAUT != 0))%7 ;
			if (F1 != 0) nouveau() ;												// Nouvau terrain alatoire
			if (F2 != 0) { prepare_tampon(Tampon) ; Moteur() ; }					// Avancer d'un tour
			if (F3 != 0) RestaureTerrain(terrain) ;									// Restaurer terrain
			if (ESCAPE != 0) goto Fin ;
			if (ENTER != 0 || SECOND != 0)
			{
				if (rang == 0) break ;
				if (rang == 1)
				{
					baisse_contraste(100) ;
					draw_menu_edit() ;
					restaure_contraste() ;
					do
					{
						attend_touche(CLIGNOTER_CURSEUR) ;
						if ((Vieilles[0]&_89_92(64,2)) != 0)						// Scroll dans la direction o va le curseur
						{
							if (GAUCHE != 0) ScrollGauche() ;
							if (DROITE != 0) ScrollDroite() ;
							if (HAUT != 0) ScrollHaut() ;
							if (BAS != 0) ScrollBas() ;
						}
						else
						{
							x1 = 64+(LargeurTerrain+x1-64+(DROITE != 0)-(GAUCHE != 0))%LargeurTerrain ;
							y1 = 2+(HauteurTerrain+y1-2+(BAS != 0)-(HAUT != 0))%HauteurTerrain ;
						}
						if ((Vieilles[0]&_89_92(16,1)) != 0) DrawPix(x1, y1, 1) ;	// Afficher un point
						if ((Vieilles[0]&_89_92(32,4)) != 0) DrawPix(x1, y1, 0) ;	// Effacer un point
						if (CLEAR != 0) ClrTerrain() ;								// Effacer tout le terrain
						if (F1 != 0) nouveau() ;									// Nouveau terrain alatoire
						if (F2 != 0) { prepare_tampon(Tampon) ; Moteur() ; }		// Avancer d'un tour
						if (F3 != 0) RestaureTerrain(terrain) ;						// Restaurer terrain
						if (F4 != 0)												// Charger motifs
						{
							var = get_motif() ;
							goto PoseImage ;
						}
						if (F5 != 0)												// Charger une image
						{
							var = get_pic() ;
							PoseImage:
							baisse_contraste(100) ; restaure_contraste() ;
							if (var != 0)
							{
								x1 = max(64,MilieuTerrainX-(var[3]>>1)) ; y1 = max(2,MilieuTerrainY-(var[1]>>1)) ;
								mode = 1 ;
								SavTerrain(bmp) ; draw_menu_pose() ;
								do
								{
									RestaureTerrain(bmp) ;
									bitmap_put(x1, y1, var, mode) ;
									Boucle() ;
									attend_touche(CLIGNOTER_CURSEUR) ;
									x1 = 64+(LargeurTerrain+x1-64+(DROITE != 0)-(GAUCHE != 0))%LargeurTerrain ;
									y1 = 2+(HauteurTerrain+y1-2+(BAS != 0)-(HAUT != 0))%HauteurTerrain ;
									mode = F1 != 0 ? 1 : (F2 != 0 ? 4 : (F3 != 0 ? 2 : mode)) ;
									if (ENTER != 0 || SECOND != 0) SavTerrain(bmp) ;
								} while (ESCAPE == 0) ;
								if (ESCAPE != 0) RestaureTerrain(bmp) ;
							}
							draw_menu_edit() ;
							#ifdef _89
								Touche[1] = Touche[6] = 0 ;
							#else
								Touche[6] = Touche[8] = Touche[9] = 0 ;
							#endif
						}
						Boucle() ;
					} while (ESCAPE == 0 && ENTER == 0) ;
				}
				if (rang == 2) change_regle() ;										// Changer les rgles
				if (rang == 3)														// Options
				{
					baisse_contraste(100) ;
					rang = 0 ; mode = TailleTerrain ;
					draw_menu_options() ;
					restaure_contraste() ;
					do
					{
						DrawStr(34, 6, TailleTerrain == NORMAL ? "Normal" : fr_eng("Grand   ", "Large   "), 4) ;
						printf_xy(fr_eng(37, 34), 14, "%d    ", attend) ;
						DrawChar(1, 6+8*rang, 18, 4) ;
						attend_touche(ANIMER_CELLULE) ;
						DrawStr(1, 6+8*rang, "  ", 4) ;
						rang = (2+rang+(BAS != 0)-(HAUT != 0))%2 ;
						if (GAUCHE != 0 || DROITE != 0)
						{
							if (rang == 0) TailleTerrain = GRAND-TailleTerrain ;
							if (rang == 1) attend = (525+attend+25*(DROITE != 0)-25*(GAUCHE != 0))%525 ;
						}
					} while (ESCAPE == 0 && ENTER == 0) ;
					if (mode != TailleTerrain) set_taille_terrain() ;
				}
				if (rang == 4)														// Sauver sous forme d'image
				{
					baisse_contraste(100) ;
					draw_menu_rect() ;
					SavTerrain(bmp) ;
					x1 = 64 ; y1 = 2 ; x2 = Xmax ; y2 = Ymax ;
					restaure_contraste() ;
					do
					{
						winrect = (WIN_RECT){x1, y1, x2, y2} ;
						DrawClipRect(&winrect, &TERRAIN, 4) ;
						attend_touche(CLIGNOTER_CURSEUR) ;
						RestaureTerrain(bmp) ;
						x1 = min(Xmax, max(64, x1+(DROITE != 0)-(GAUCHE != 0))) ;
						y1 = min(Ymax, max(2, y1+(BAS != 0)-(HAUT != 0))) ;
						if (F1 != 0)
						{
							x1 = 64 ; y1 = 2 ;
						}
						if (ESCAPE != 0) goto Fin_rect ;
					} while (ENTER == 0 && SECOND == 0) ;
					DrawStr(3, 28, fr_eng("2me coin ?", "2nd corner?"), 4) ;
					x2 = x1 ; y2 = y1 ; x1 = Xmax ; y1 = Ymax ;
					do
					{
						winrect = (WIN_RECT){x1, y1, x2, y2} ;
						DrawClipRect(&winrect, &TERRAIN, 4) ;
						attend_touche(CLIGNOTER_CURSEUR) ;
						RestaureTerrain(bmp) ;
						x1 = min(Xmax, max(x2, x1+(DROITE != 0)-(GAUCHE != 0))) ;
						y1 = min(Ymax, max(y2, y1+(BAS != 0)-(HAUT != 0))) ;
						if (F1 != 0)
						{
							x2 = 64 ; x1 = Xmax ;
							y2 = 2 ; y1 = Ymax ;
						}
						if (ESCAPE != 0) goto Fin_rect ;
					} while (ENTER == 0 && SECOND == 0) ;
					rect = (SCR_RECT){{x2, y2, x1, y1}} ;
					rang = BitmapSize(&rect) ;
					strcpy(nom, get_folder()) ;
					if (ESCAPE != 0) goto Fin_rect ;
					if (nom != NULL) strcat(nom, "\\") ;
					var = mk_ptr(strcat(nom, "pic"), rang+3) ;
					if (var != NULL)
					{
						BitmapGet(&rect, var) ;
						var[rang] = PIC_TAG ;
					}
					else
					{
						clr_interface() ;
						draw_str_petit(3, 20, fr_eng("Impossible de", "Could not")) ;
						draw_str_petit(3, 28, fr_eng("crer le fichier !", "create file!")) ;
						attend_touche(RIEN_FAIRE) ;
					}
				}
Fin_rect:
				if (rang == 5) disp_apropos() ;										// A propos
				if (rang == 6) goto Fin ;											// Quitter
				baisse_contraste(100) ;
				draw_menu() ; rang = 0 ;
				restaure_contraste() ;
			}
		}
		baisse_contraste(100) ;
	}

	Fin:
	baisse_contraste(150) ;
	LCD_restore(lcd) ;
	ST_helpMsg("http://leiber.free.fr") ;
	free(Tampon) ; free(Alphabet) ; free(LargeurLettre) ; free(bmp) ; free(lcd) ; free(terrain) ;
	restaure_int() ; restaure_contraste() ;
}
